﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;

namespace chc.servicemanagertray
{
    public class ResourceHelper
    {
        [DllImport("kernel32.dll", SetLastError = true)]
        static extern bool FreeLibrary(IntPtr hModule);

        [DllImport("user32.dll", CharSet = CharSet.Auto)]
        static extern int LoadString(IntPtr hInstance, uint uID, StringBuilder lpBuffer, int nBufferMax);

        [DllImport("kernel32.dll", CharSet = CharSet.Auto)]
        static extern IntPtr LoadLibrary(string lpFileName);
        
        public static string LoadWin32Resource(string description)
        {
            string[] resource_details = description.Split(',');
            string resource_dll_path = resource_details[0].Substring(1);
            string resource_id = resource_details[1].Substring(1);
            uint resrouce_id_uint = uint.Parse(resource_id);

            resource_dll_path = System.Environment.ExpandEnvironmentVariables(resource_dll_path);

            IntPtr handle_lib = LoadLibrary(resource_dll_path);
            StringBuilder resource_buffer = new StringBuilder(1204);
            LoadString(handle_lib, resrouce_id_uint, resource_buffer, resource_buffer.Capacity + 1);
            FreeLibrary(handle_lib);
            return resource_buffer.ToString();

        }
    }
}
